/*
///////////////////////////////////////////////////////////////////////////////////////////////////
//
//	FileName	Main.c
//	Version		1.00
//	MCU		H8/3694
//	Work		
//-------------------------------------------------------------------------------------------------
//
//	2007/04/19	Ver1.00
//-------------------------------------------------------------------------------------------------
//ldln
//	rv̓ɍ킹Ăkdc_vOłB
//	fBbvXCb`̂nm^neeɍ킹āAkdc_s܂B
//	rvQArvRł͂kdcБ珇_܂
//-------------------------------------------------------------------------------------------------
*/

/*

̃\tgEFA̓t[EFAłB

̃\tgEFAɊւ鎿ɂ܂ẮA
T|[g̑ΏۊOƂȂ܂B

쌠͍쐬ł()kldqL̂Ƃ܂B

̃\tgEFAgpƂɂSĂ̑QɂāA
쐬͈؂̐ӔC𕉂Ȃ̂Ƃ܂B

̃\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ
֎~܂BGȂǂ֏ЉE^̏ꍇ͘A肢v
܂B

@Copyright (C) Hokuto denshi Co,Ltd. 2007

*/


/*
/////////////////////////////////////////////////////////////////////////////////////////
//CN[ht@C錾
*/
/* }CRCu */
#include <machine.h>

/* WbCu */

/* IWi */
#include "3694S.h"
#include "Main.h"
#include "Switch.h"
#include "LED.h"


/*
/////////////////////////////////////////////////////////////////////////////////////////
//萔錾
*/


/*
/////////////////////////////////////////////////////////////////////////////////////////
//^錾
*/


/*
/////////////////////////////////////////////////////////////////////////////////////////
//ϐ錾
*/


/*
/////////////////////////////////////////////////////////////////////////////////////////
//}N錾
*/


/*
/////////////////////////////////////////////////////////////////////////////////////////
//֐vg^Cv錾
*/
void PowerOnReset ( void );
void Main ( void );
int Init ( void );
void Wait ( const unsigned long Interval );
void Event_SW ( const unsigned char SwitchNumber );


/*
/////////////////////////////////////////////////////////////////////////////////////////
//֐vg^Cv錾
*/


/*
///////////////////////////////////////////////////////////////////////////////
//PowerOnReset
//Ep[IZbg
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
void PowerOnReset ( void )
{
	set_imask_ccr ( 0 );
	_INITSCT ();
	Main ();
	sleep ();
}


/*
///////////////////////////////////////////////////////////////////////////////
//Main
//EvOC
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
void Main ( void )
{
	unsigned char Switch[ 4 ];
	
	
	if ( Init () != NOERROR )
		return;
	
	
	while ( 1 )
	{
		Switch[ 0 ] = ( Read_Switch ( VAL_SWITCH_DIP_A ) == VAL_LED_LEVEL_LOW ? VAL_LED_LEVEL_HIGH : VAL_LED_LEVEL_LOW );
		Switch[ 1 ] = ( Read_Switch ( VAL_SWITCH_DIP_B ) == VAL_LED_LEVEL_LOW ? VAL_LED_LEVEL_HIGH : VAL_LED_LEVEL_LOW );
		Switch[ 2 ] = ( Read_Switch ( VAL_SWITCH_DIP_C ) == VAL_LED_LEVEL_LOW ? VAL_LED_LEVEL_HIGH : VAL_LED_LEVEL_LOW );
		Switch[ 3 ] = ( Read_Switch ( VAL_SWITCH_DIP_D ) == VAL_LED_LEVEL_LOW ? VAL_LED_LEVEL_HIGH : VAL_LED_LEVEL_LOW );
		
		
		Set_LED ( VAL_LED_NUMBER_1, Switch[ 0 ] );
		Set_LED ( VAL_LED_NUMBER_2, Switch[ 1 ] );
		Set_LED ( VAL_LED_NUMBER_3, Switch[ 2 ] );
		Set_LED ( VAL_LED_NUMBER_4, Switch[ 3 ] );
	}
}


/*
///////////////////////////////////////////////////////////////////////////////
//Init
//EvO
//-----------------------------------------------------------------------------
//return int
//	NOERROR			: 
//	ERROR_FATAL		: G[
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
int Init ( void )
{
	if ( Init_Switch ( Event_SW ) != NOERROR )
		return ERROR_FATAL;
	else if ( Init_LED () != NOERROR )
		return ERROR_FATAL;
	
	
	return NOERROR;
}


/*
///////////////////////////////////////////////////////////////////////////////
//Event_SW
//ErvCxg
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
void Event_SW ( const unsigned char SwitchNumber )
{
	switch ( SwitchNumber )
	{
	case VAL_SWITCH2:
		Set_LED ( VAL_LED_NUMBER_ALL, VAL_LED_LEVEL_LOW );
		Set_LED ( VAL_LED_NUMBER_1, VAL_LED_LEVEL_HIGH );
		Wait ( 100 );
		Set_LED ( VAL_LED_NUMBER_ALL, VAL_LED_LEVEL_LOW );
		Set_LED ( VAL_LED_NUMBER_2, VAL_LED_LEVEL_HIGH );
		Wait ( 100 );
		Set_LED ( VAL_LED_NUMBER_ALL, VAL_LED_LEVEL_LOW );
		Set_LED ( VAL_LED_NUMBER_3, VAL_LED_LEVEL_HIGH );
		Wait ( 100 );
		Set_LED ( VAL_LED_NUMBER_ALL, VAL_LED_LEVEL_LOW );
		Set_LED ( VAL_LED_NUMBER_4, VAL_LED_LEVEL_HIGH );
		Wait ( 100 );
		break;
		
	case VAL_SWITCH3:
		Set_LED ( VAL_LED_NUMBER_ALL, VAL_LED_LEVEL_LOW );
		Set_LED ( VAL_LED_NUMBER_4, VAL_LED_LEVEL_HIGH );
		Wait ( 100 );
		Set_LED ( VAL_LED_NUMBER_ALL, VAL_LED_LEVEL_LOW );
		Set_LED ( VAL_LED_NUMBER_3, VAL_LED_LEVEL_HIGH );
		Wait ( 100 );
		Set_LED ( VAL_LED_NUMBER_ALL, VAL_LED_LEVEL_LOW );
		Set_LED ( VAL_LED_NUMBER_2, VAL_LED_LEVEL_HIGH );
		Wait ( 100 );
		Set_LED ( VAL_LED_NUMBER_ALL, VAL_LED_LEVEL_LOW );
		Set_LED ( VAL_LED_NUMBER_1, VAL_LED_LEVEL_HIGH );
		Wait ( 100 );
		break;
	}
}


/*
///////////////////////////////////////////////////////////////////////////////
//Wait
//EvOҋ@
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
void Wait ( const unsigned long Interval )
{
	volatile unsigned long i;
	for ( i = 0; i < Interval * 1000; ++i ) {}
}
