/*
///////////////////////////////////////////////////////////////////////////////////////////////////
//shnQ@kdcvO
//	FileName	LED.c
//	Version		1.00
//	MCU		H8/3694
//	Work		
//-------------------------------------------------------------------------------------------------
//
//	2007/04/19	Ver1.00
//-------------------------------------------------------------------------------------------------
*/

/*

̃\tgEFA̓t[EFAłB

̃\tgEFAɊւ鎿ɂ܂ẮA
T|[g̑ΏۊOƂȂ܂B

쌠͍쐬ł()kldqL̂Ƃ܂B

̃\tgEFAgpƂɂSĂ̑QɂāA
쐬͈؂̐ӔC𕉂Ȃ̂Ƃ܂B

̃\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ
֎~܂BGȂǂ֏ЉE^̏ꍇ͘A肢v
܂B

@Copyright (C) Hokuto denshi Co,Ltd. 2007

*/


/*
/////////////////////////////////////////////////////////////////////////////////////////
//CN[ht@C錾
*/
/* }CRCu */
#include <machine.h>

/* WbCu */
#include <stdio.h>

/* IWi */
#include "3694S.h"
#include "Main.h"
#include "Switch.h"


/*
/////////////////////////////////////////////////////////////////////////////////////////
//萔錾
*/


/*
/////////////////////////////////////////////////////////////////////////////////////////
//^錾
*/


/*
/////////////////////////////////////////////////////////////////////////////////////////
//ϐ錾
*/
FUNC_SWITCHEVENT m_FuncSwitch = NULL;


/*
/////////////////////////////////////////////////////////////////////////////////////////
//}N錾
*/


/*
/////////////////////////////////////////////////////////////////////////////////////////
//֐vg^Cv錾
*/
int Init_Switch ( const FUNC_SWITCHEVENT Switch );
unsigned char Read_Switch ( const unsigned char Number );


/*
/////////////////////////////////////////////////////////////////////////////////////////
//֐vg^Cv錾
*/


/*
///////////////////////////////////////////////////////////////////////////////
//Init_Switch
//EXCb`
//-----------------------------------------------------------------------------
//return int
//	NOERROR			: 
//	ERROR_FATAL		: G[
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
int Init_Switch ( const FUNC_SWITCHEVENT Switch )
{
	/* XCb`p|[g */
	IO.PMR1.BIT.IRQ1 = 1;
	IO.PMR1.BIT.IRQ2 = 1;
	AD.ADCSR.BIT.CH = 7;	/* `c`lSahsڂ܂͂S`VahsڂɎw */
	
	
	/* 荞ݐݒ */
	IEGR1.BIT.IEG1 = 0;
	IEGR1.BIT.IEG2 = 0;
	IENR1.BIT.IEN1 = 1;
	IENR1.BIT.IEN2 = 1;
	
	
	/* XCb`荞ݎs֐o^ */
	m_FuncSwitch = Switch;
	
	
	/* I */
	return NOERROR;
}


/*
///////////////////////////////////////////////////////////////////////////////
//Read_Switch
//EXCb`ǂݍ
//-----------------------------------------------------------------------------
//return unsigned char
//
//-----------------------------------------------------------------------------
//param In	Number		: XCb`ԍ
//-----------------------------------------------------------------------------
*/
unsigned char Read_Switch ( const unsigned char Number )
{
	/* ϐ錾 */
	unsigned char Result;
	
	
	/* XCb`Ԏ擾 */
	switch ( Number )
	{
	case VAL_SWITCH_DIP_A:/* choXCb`` */
		Result = IO.PDRB.BIT.B0;
		break;
		
	case VAL_SWITCH_DIP_B:/* choXCb`a */
		Result = IO.PDRB.BIT.B1;
		break;
		
	case VAL_SWITCH_DIP_C:/* choXCb`b */
		Result = IO.PDRB.BIT.B2;
		break;
		
	case VAL_SWITCH_DIP_D:/* choXCb`c */
		Result = IO.PDRB.BIT.B3;
		break;
		
	default:
		Result = VAL_SWITCH_LOW;
		break;
	}
	
	
	/* I */
	return Result;
}


/*
///////////////////////////////////////////////////////////////////////////////
//Interrupt_Switch_2
//EXCb`Q荞
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
#pragma interrupt ( Interrupt_Switch_2 )
void Interrupt_Switch_2 ( void )
{
	IRR1.BIT.IRRI2 = 0;
	if ( m_FuncSwitch != NULL )
		m_FuncSwitch ( VAL_SWITCH2 );
}


/*
///////////////////////////////////////////////////////////////////////////////
//Interrupt_Switch_3
//EXCb`R荞
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
#pragma interrupt ( Interrupt_Switch_3 )
void Interrupt_Switch_3 ( void )
{
	IRR1.BIT.IRRI1 = 0;
	if ( m_FuncSwitch != NULL )
		m_FuncSwitch ( VAL_SWITCH3 );
}
